var tileCount = 4;
var tileLogic = boardSize/(tileCount/dispSize);
var tileSize = boardSize/tileCount;

context.scale(dispSize,dispSize);

var clickLoc = new Object;
clickLoc.x = 0;
clickLoc.y = 0;

var emptyLoc = new Object;
emptyLoc.x = 0;
emptyLoc.y = 0;

var solved = false;

var boardParts = new Object;
setBoard();

document.getElementById('puzzle').onmousemove = function(e){
clickLoc.x = Math.floor((e.pageX - this.offsetLeft)/tileLogic);
clickLoc.y = Math.floor((e.pageY - this.offsetTop)/tileLogic);
}

document.getElementById('puzzle').onclick = function(){
if (distance(clickLoc.x, clickLoc.y, emptyLoc.x, emptyLoc.y) == 1){
slideTile(emptyLoc, clickLoc);
drawTiles();
}
if(solved){
++score;
nextLevel();}
}

function setBoard(){
boardParts = new Array(tileCount);
for (var i = 0; i < tileCount; ++i){
boardParts[i] = new Array(tileCount);
for (var j = 0; j < tileCount; ++j){
boardParts[i][j] = new Object;
boardParts[i][j].x = (tileCount - 1) - i;
boardParts[i][j].y = (tileCount - 1) - j; 
}
}
emptyLoc.x = boardParts[tileCount - 1][tileCount - 1].x;
emptyLoc.y = boardParts[tileCount - 1][tileCount - 1].y;
solved = false;
}

function drawTiles(){
context.clearRect(0, 0, boardSize, boardSize);
context.fillStyle="#ffa10b";
context.fillRect(0, 0, boardSize, boardSize);
for (var i = 0; i < tileCount; ++i) {
for (var j = 0; j < tileCount; ++j) {
var x = boardParts[i][j].x;
var y = boardParts[i][j].y;
if(i != emptyLoc.x || j !=emptyLoc.y || solved == true){
context.drawImage(imageObj, x*tileSize, y*tileSize, tileSize, tileSize, i*tileSize, j*tileSize, tileSize, tileSize);
}
}
}
}

function distance(x1, y1, x2, y2){
return Math.abs(x1 - x2) + Math.abs(y1 - y2);
}

function slideTile(toLoc, fromLoc){
if(!solved){
boardParts[toLoc.x][toLoc.y].x = boardParts[fromLoc.x][fromLoc.y].x;
boardParts[toLoc.x][toLoc.y].y = boardParts[fromLoc.x][fromLoc.y].y;
boardParts[fromLoc.x][fromLoc.y].x = tileCount - 1;
boardParts[fromLoc.x][fromLoc.y].y = tileCount - 1;
toLoc.x = fromLoc.x;
toLoc.y = fromLoc.y;
checkSolved();
}
}

function checkSolved(){
var flag = true;
for (var i = 0; i < tileCount; ++i) {
for (var j = 0; j < tileCount; ++j) {
if (boardParts[i][j].x != i || boardParts [i][j].y !=j){
flag = false;
}
}
}
solved = flag;
}

function showSolution (){
switch(document.getElementById('solution').innerHTML){
case 'Show Solution':
document.getElementById('solution').innerHTML = 'Hide Solution';
context.drawImage(imageObj,0,0, 1000, 1000);
break
case 'Hide Solution':
document.getElementById('solution').innerHTML = 'Show Solution';
drawTiles();
}
}

function nextLevel(){
if (num == pictures.length-1){
document.getElementById('finish_menu').style.display = 'block';
if(score >=1){
canvas.style.display = 'none';
document.getElementById('score').innerHTML = 'You solved '+score+' puzzles!';
document.getElementById('congrats').innerHTML = 'Congratulations!';
}
if(score < 1){
canvas.style.display = 'none';
document.getElementById('score').innerHTML = 'You solved '+screen.width+'puzzles!';
document.getElementById('congrats').innerHTML = "That"+"'"+"s bad!";
}
document.getElementById('finish_menu').style.display = 'block';
} else{
document.getElementById('solution').innerHTML = 'Show Solution';
++num;
imageObj.src = pictures[num];
setBoard();
}
}

function startGame(){
document.getElementById('game_menu').style.display = 'block';
document.getElementById('main_menu').style.display = 'none';
}